#pragma once
#include <iostream> 
using namespace std;
//˲ڵ  
template<class T>
struct OctreeNode
{
	T data; //ڵ  
	T xmin, xmax; //ڵ꣬  
	T ymin, ymax;
	T zmin, zmax;
	OctreeNode <T>* top_left_front, * top_left_back; //ýڵĸӽ  
	OctreeNode <T>* top_right_front, * top_right_back;
	OctreeNode <T>* bottom_left_front, * bottom_left_back;
	OctreeNode <T>* bottom_right_front, * bottom_right_back;
	OctreeNode //ڵ  
	(T nodeValue = T(),
		T xminValue = T(), T xmaxValue = T(),
		T yminValue = T(), T ymaxValue = T(),
		T zminValue = T(), T zmaxValue = T(),
		OctreeNode<T>* top_left_front_Node = NULL,
		OctreeNode<T>* top_left_back_Node = NULL,
		OctreeNode<T>* top_right_front_Node = NULL,
		OctreeNode<T>* top_right_back_Node = NULL,
		OctreeNode<T>* bottom_left_front_Node = NULL,
		OctreeNode<T>* bottom_left_back_Node = NULL,
		OctreeNode<T>* bottom_right_front_Node = NULL,
		OctreeNode<T>* bottom_right_back_Node = NULL)
		:data(nodeValue),
		xmin(xminValue), xmax(xmaxValue),
		ymin(yminValue), ymax(ymaxValue),
		zmin(zminValue), zmax(zmaxValue),
		top_left_front(top_left_front_Node),
		top_left_back(top_left_back_Node),
		top_right_front(top_right_front_Node),
		top_right_back(top_right_back_Node),
		bottom_left_front(bottom_left_front_Node),
		bottom_left_back(bottom_left_back_Node),
		bottom_right_front(bottom_right_front_Node),
		bottom_right_back(bottom_right_back_Node) {}
};
//˲  
template <class T>
void createOctree(OctreeNode<T>*& root, int maxdepth, double xmin, double xmax, double ymin, double ymax, double zmin, double zmax)
{
	//cout<<"УԺ򡭡"<<endl;  
	maxdepth = maxdepth - 1; //ÿݹһξͽݹ-1  
	if (maxdepth >= 0)
	{
		root = new OctreeNode<T>();
		//cout << "ڵֵ:";
		//root->data =9;//Ϊڵ㸳ֵԴ洢ڵϢɼԡǼʵְ˲ܣ򵥸ֵΪ9  
		cin >> root->data;  //Ϊڵ㸳ֵ  
		root->xmin = xmin; //Ϊڵ긳ֵ  
		root->xmax = xmax;
		root->ymin = ymin;
		root->ymax = ymax;
		root->zmin = zmin;
		root->zmax = zmax;
		double xm = (xmax - xmin) / 2;//ڵάϵİ߳  
		double ym = (ymax - ymin) / 2;
		double zm = (ymax - ymin) / 2;
		//ݹ鴴ÿһڵǼŽڵ㣩λþӽꡣ  
		createOctree(root->top_left_front, maxdepth, xmin, xmax - xm, ymax - ym, ymax, zmax - zm, zmax);
		createOctree(root->top_left_back, maxdepth, xmin, xmax - xm, ymin, ymax - ym, zmax - zm, zmax);
		createOctree(root->top_right_front, maxdepth, xmax - xm, xmax, ymax - ym, ymax, zmax - zm, zmax);
		createOctree(root->top_right_back, maxdepth, xmax - xm, xmax, ymin, ymax - ym, zmax - zm, zmax);
		createOctree(root->bottom_left_front, maxdepth, xmin, xmax - xm, ymax - ym, ymax, zmin, zmax - zm);
		createOctree(root->bottom_left_back, maxdepth, xmin, xmax - xm, ymin, ymax - ym, zmin, zmax - zm);
		createOctree(root->bottom_right_front, maxdepth, xmax - xm, xmax, ymax - ym, ymax, zmin, zmax - zm);
		createOctree(root->bottom_right_back, maxdepth, xmax - xm, xmax, ymin, ymax - ym, zmin, zmax - zm);
	}
}
int i = 1;
//˲  
template <class T>
void preOrder(OctreeNode<T>*& p)
{
	if (p)
	{
		//cout << i << ".ǰڵֵΪ" << p->data << "\nΪ";
		//cout << "xmin: " << p->xmin << " xmax: " << p->xmax;
		//cout << "ymin: " << p->ymin << " ymax: " << p->ymax;
		//cout << "zmin: " << p->zmin << " zmax: " << p->zmax;
		i += 1;
		cout << endl;
		preOrder(p->top_left_front);
		preOrder(p->top_left_back);
		preOrder(p->top_right_front);
		preOrder(p->top_right_back);
		preOrder(p->bottom_left_front);
		preOrder(p->bottom_left_back);
		preOrder(p->bottom_right_front);
		preOrder(p->bottom_right_back);
		cout << endl;
	}
}
//˲  
template<class T>
int depth(OctreeNode<T>*& p)
{
	if (p == NULL)
		return -1;
	int h = depth(p->top_left_front);
	return h + 1;
}
template<class T>
int num(OctreeNode<T>*& p)
{
	if (p == NULL)
		return 0;
	return 1 + num(p->top_left_front) + num(p->top_left_back) + num(p->top_right_back) + num(p->top_right_front) + num(p->bottom_left_back) + num(p->bottom_left_front) + num(p->bottom_right_back) + num(p->bottom_right_front);
}
//㵥λȣΪҵ׼  
int cal(int num)
{
	int result = 1;
	if (1 == num)
		result = 1;
	else
	{
		for (int i = 1; i < num; i++)
			result = 2 * result;
	}
	return result;
}

template<class T>
int find(OctreeNode<T>*& p, double x, double y, double z)
{
	//ҵ  
	int maxdepth = 0;
	int times = 0;
	static double xmin = 0, xmax = 0, ymin = 0, ymax = 0, zmin = 0, zmax = 0;
	int tmaxdepth = 0;
	double txm = 1, tym = 1, tzm = 1;

	double xm = (p->xmax - p->xmin) / 2;
	double ym = (p->ymax - p->ymin) / 2;
	double zm = (p->ymax - p->ymin) / 2;
	times++;
	if (x > xmax || x<xmin || y>ymax || y<ymin || z>zmax || z < zmin)
	{
		//cout << "õ㲻ڳУ" << endl;
		return 0;
	}
	if (x <= p->xmin + txm && x >= p->xmax - txm && y <= p->ymin + tym && y >= p->ymax - tym && z <= p->zmin + tzm && z >= p->zmax - tzm)
	{
		//cout << endl << "ҵõ㣡" << "õλ" << endl;
		//cout << "xmin: " << p->xmin << " xmax: " << p->xmax;
		//cout << "ymin: " << p->ymin << " ymax: " << p->ymax;
		//cout << "zmin: " << p->zmin << " zmax: " << p->zmax;
		//cout << "ڵڣ" << endl;
		//cout << "" << times << "εݹ飡" << endl;
		return 1;
	}
	else if (x < (p->xmax - xm) && y < (p->ymax - ym) && z < (p->zmax - zm))
	{
		find(p->bottom_left_back, x, y, z);
	}
	else if (x < (p->xmax - xm) && y<(p->ymax - ym) && z>(p->zmax - zm))
	{
		find(p->top_left_back, x, y, z);
	}
	else if (x > (p->xmax - xm) && y < (p->ymax - ym) && z < (p->zmax - zm))
	{
		find(p->bottom_right_back, x, y, z);
	}
	else if (x > (p->xmax - xm) && y<(p->ymax - ym) && z>(p->zmax - zm))
	{
		find(p->top_right_back, x, y, z);
	}
	else if (x<(p->xmax - xm) && y>(p->ymax - ym) && z < (p->zmax - zm))
	{
		find(p->bottom_left_front, x, y, z);
	}
	else if (x<(p->xmax - xm) && y>(p->ymax - ym) && z > (p->zmax - zm))
	{
		find(p->top_left_front, x, y, z);
	}
	else if (x > (p->xmax - xm) && y > (p->ymax - ym) && z < (p->zmax - zm))
	{
		find(p->bottom_right_front, x, y, z);
	}
	else if (x > (p->xmax - xm) && y > (p->ymax - ym) && z > (p->zmax - zm))
	{
		find(p->top_right_front, x, y, z);
	}
}
//main  
/*
int main()
{
	OctreeNode<double>* rootNode = NULL;
	int choiced = 0;
	cout << "ϵͳʼǰȴ˲" << endl;
	cout << "ݹȣ" << endl;
	cin >> maxdepth;
	cout << "꣬˳£xmin,xmax,ymin,ymax,zmin,zmax" << endl;
	cin >> xmin >> xmax >> ymin >> ymax >> zmin >> zmax;
	if (maxdepth >= 0 || xmax > xmin || ymax > ymin || zmax > zmin || xmin > 0 || ymin > 0 || zmin > 0)
	{
		tmaxdepth = cal(maxdepth);
		txm = (xmax - xmin) / tmaxdepth;
		tym = (ymax - ymin) / tmaxdepth;
		tzm = (zmax - zmin) / tmaxdepth;
		createOctree(rootNode, maxdepth, xmin, xmax, ymin, ymax, zmin, zmax);
	}
	while (true)
	{
		system("cls");

		cout << "ѡ\n";
		cout << "\t1.ռĸ\n";
		cout << "\t2.˲\n";
		cout << "\t3.鿴\n";
		cout << "\t4.ҽڵ   \n";
		cout << "\t0.˳\n";
		cin >> choiced;

		if (choiced == 0)
			return 0;
		if (choiced == 1)
		{
			system("cls");
			cout << "ռ" << endl;
			cout << num(rootNode);
		}

		if (choiced == 2)
		{
			system("cls");
			cout << "˲/n";
			i = 1;
			preOrder(rootNode);
			cout << endl;
			system("pause");
		}
		if (choiced == 3)
		{
			system("cls");
			int dep = depth(rootNode);
			cout << "˰˲Ϊ" << dep + 1 << endl;
			system("pause");
		}
		if (choiced == 4)
		{
			system("cls");
			cout << "ϣҵĵ꣬˳£x,y,z\n";
			double x, y, z;
			cin >> x >> y >> z;
			times = 0;
			cout << endl << "ʼѰõ㡭" << endl;
			find(rootNode, x, y, z);
			system("pause");
		}
		else
		{
			system("cls");
			cout << "\n\nѡ\n";
			system("pause");
		}
	}
*/