#pragma once
///
/// 㷨
/// 
//#define EIGEN_USE_MKL_ALL
//#define EIGEN_VECTORIZE_SSE4_2
//#include <mkl.h>
// ط
#include "baseTool.h"
#include <iostream>
#include <Eigen/Core>
#include <Eigen/Dense>
#include <time.h>
//#include <mkl.h>
#include <omp.h>
#include "SateOrbit.h"
#include "ImageMatch.h"
using namespace std;
using namespace Eigen;

////////////// ú ////////////////////////

double getRangeColumn(long double R, long double NearRange, long double Fs, long double lamda);
Eigen::MatrixXd getRangeColumn(Eigen::MatrixXd R, long double NearRange, long double Fs, long double lamda);

double getRangebyColumn(double j, long double NearRange, long double Fs, long double lamda);
Eigen::MatrixXd getRangebyColumn(Eigen::MatrixXd j, long double NearRange, long double Fs, long double lamda);
/////////////  ptsn 㷨 /////////////////////

class PSTNAlgorithm {
public:
	// ʼ
	PSTNAlgorithm();
	PSTNAlgorithm(string parameterPath);
	~PSTNAlgorithm();

	int dem2lat_lon(std::string dem_path, std::string lon_path, std::string lat_path);
	int dem2SAR_RC(std::string dem_path, std::string sim_rc_path);
	
	// ģ㷨
	Eigen::MatrixX<double> calNumericalDopplerValue(Eigen::MatrixX<double> R);// ֵģⷨƵֵ
	double calNumericalDopplerValue(double R);// ֵģⷨƵֵ
	Eigen::MatrixX<double> calTheoryDopplerValue(Eigen::MatrixX<double> R, Eigen::MatrixX<double> R_s1, Eigen::MatrixX<double> V_s1);//ģͼƵֵ
	double calTheoryDopplerValue(double R, Eigen::MatrixX<double> R_s1, Eigen::MatrixX<double> V_s1);
	Eigen::MatrixX<double> PSTN(Eigen::MatrixX<double> TargetPostion, double ave_dem, double dt, bool isCol ); // DEM
	//Eigen::MatrixXd WGS842J2000(Eigen::MatrixXd blh);
	//Landpoint WGS842J2000(Landpoint p);
public: // WGS84  J2000 ֮ı任
	Eigen::MatrixXd UTC;
	double Xp = 0.204071;
	double Yp = 0.318663;
	double Dut1 = 0.0366742;
	double Dat = 37;
public:
	int height; // Ӱĸ
	int width;

	// 
	double near_in_angle;// 
	double far_in_angle;// Զ

	// SARĳ
	double fs;// 
	double R0;//б
	double LightSpeed; // 
	double lamda;// 
	double refrange;// οб

	double imgStartTime;// ʼʱ
	double PRF;// ظ

	int doppler_paramenter_number;//ϵ
	MatrixX<double> doppler_paras;// ϵ
	
	OrbitPoly orbit; // ģ

};


/// <summary>
/// ȡֵǣǶֵ
/// </summary>
/// <param name="satepoint"></param>
/// <param name="landpoint"></param>
/// <param name="slopeVector"></param>
/// <returns></returns>
double getlocalIncAngle(Landpoint& satepoint, Landpoint& landpoint, Landpoint& slopeVector);


/// <summary>
/// ,Ƕֵ
/// </summary>
/// <param name="satepoint"></param>
/// <param name="landpoint"></param>
/// <returns></returns>
double getIncAngle(Landpoint& satepoint, Landpoint& landpoint);


/// <summary>
/// ASF㷽
/// </summary>
class ASFOrthClass {

public:
	Eigen::MatrixXd Satellite2ECR(Eigen::Vector3d Rsc, Eigen::Vector3d Vsc); // 任 M
	Eigen::Vector3d UnitVectorOfSatelliteAndTarget(double alpha, double beta, Eigen::MatrixXd M);
	double GetLookFromRangeYaw(double R, double alpha, double beta, Eigen::Vector3d SatellitePosition, Eigen::Vector3d SatelliteVelocity, double R_threshold, double H = 0);
	
	Eigen::Vector3d GetXYZByBetaAlpha(double alpha,double beta, Eigen::Vector3d SatellitePosition,double R, Eigen::MatrixXd M);

	double FD(double alpha, double beta, Eigen::Vector3d SatelliteVelocity, Eigen::Vector3d TargetVelocity,double  R,double  lamda, Eigen::MatrixXd M);
	double FR(double alpha, double beta, Eigen::Vector3d SatellitePosition, Eigen::MatrixXd M, double R_threshold, double H = 0);

	Eigen::Vector3d ASF(double R, Eigen::Vector3d SatellitePosition, Eigen::Vector3d SatelliteVelocity, Eigen::Vector3d TargetPosition, PSTNAlgorithm PSTN, double R_threshold, double H = 0, double alpha0 = 0, double beta0 = 0);

};

/// <summary>
/// 洦
/// </summary>
class simProcess {
public:
	simProcess();
	~simProcess();

	int parameters(int argc, char* argv[]);

	int InitSimulationSAR(std::string paras_path,std::string workspace_path,std::string out_dir_path,std::string in_dem_path,std::string in_sar_path); // Ӷλ
	
	int CreateSARDEM();
	int dem2SAR(); // лк
	int SARIncidentAngle();
	int SARSimulationWGS();
	int SARSimulation();
	int in_sar_power();
	int ReflectTable_WGS2Range();

	int InitRPCIncAngle(std::string paras_path, std::string workspace_path, std::string out_dir_path, std::string in_dem_path,std::string in_rpc_lon_lat_path,std::string out_inc_angle_path, std::string out_local_inc_angle_path, std::string out_inc_angle_geo_path, std::string out_local_inc_angle_geo_path);
	int dem2SAR_row(); // лк
	int SARIncidentAngle_RPC();
	int createRPCDEM();

	// ɢֵ
	int Scatter2Grid(std::string lon_lat_path, std::string data_tiff, std::string grid_path, double space);

	// ASF ģ
	int InitASFSAR(std::string paras_path, std::string workspace_path, std::string out_dir_path, std::string in_dem_path);

	int ASF(std::string in_dem_path, std::string out_latlon_path, ASFOrthClass asfclass, PSTNAlgorithm PSTN);

	//int dem2simSAR(std::string dem_path, std::string out_sim_path, PSTNAlgorithm PSTN); // DEMͼ
	int sim_SAR(std::string dem_path, std::string sim_rc_path, std::string sim_sar_path, PSTNAlgorithm PSTN);
	int dem2aspect_slope(std::string dem_path, std::string aspect_path, std::string slope_path);
	int sim_sum_SAR(std::string sim_dem_path,std::string sim_rc_path, std::string sim_orth_path, std::string sim_sum_path,PSTNAlgorithm pstn);
	void interpolation_GTC_sar_sigma(std::string in_rc_wgs84_path, std::string in_ori_sar_path, std::string out_orth_sar_path, PSTNAlgorithm pstn);
	// ԭʼӰǿͼ
	int ori_sar_power(std::string ori_sar_path, std::string out_sar_power_path);

	// ƥƫģ͹
	int createImageMatchModel(std::string ori_sar_rsc_path, std::string ori_sar_rsc_jpg_path, std::string sim_sar_path, std::string sim_sar_jpg_path, std::string matchmodel_path);

	// Ӱ
	int correctOrth_rc(std::string sim_rc_path,ImageMatch matchmodel);

	int correct_ati(std::string orth_rc_path, std::string dem_path, std::string out_inclocal_path, std::string out_dem_path, std::string out_count_path, PSTNAlgorithm PSTN);

	void calcalIncident_localIncident_angle(std::string in_dem_path, std::string in_rc_wgs84_path, std::string out_incident_angle_path, std::string out_local_incident_angle_path, PSTNAlgorithm PSTN);

	void calGEC_Incident_localIncident_angle(std::string in_dem_path, std::string in_gec_lon_lat_path,std::string  out_incident_angle_path, std::string out_local_incident_angle_path,PSTNAlgorithm PSTN);

	void interpolation_GTC_sar(std::string in_rc_wgs84_path, std::string   in_ori_sar_path, std::string   out_orth_sar_path, PSTNAlgorithm pstn);
	// RPC
	void CreateRPC_DEM(std::string in_rpc_rc_path, std::string in_dem_path, std::string out_rpc_dem_path);

	void CreateRPC_refrenceTable(string in_rpc_tiff_path, string in_merge_dem, string out_rpc_lon_lat_tiff_path);

	void CorrectionFromSLC2Geo(string in_lon_lat_path, string in_radar_path, string out_radar_path, int in_band_ids);


// ڲ
public:
	ImageMatch matchmodel;
	bool isMatchModel;

	std::string workSpace_path;// ռ·
	std::string outSpace_path;// ռ·
	PSTNAlgorithm pstn; // 
	/////  RPC ֵ   ///////////////////////////////////
	std::string in_rpc_lon_lat_path;
	std::string out_dir_path;
	std::string workspace_path;
	// ʱļ
	std::string rpc_wgs_path;
	std::string ori_sim_count_tiff;// ӳļ
	// ļ
	std::string out_inc_angle_rpc_path;
	std::string out_local_inc_angle_rpc_path;

	// ļ
	std::string out_inc_angle_geo_path;
	std::string out_local_inc_angle_geo_path;

	///// 淽 /////////


	
	// ʱƷļ
	std::string in_dem_path; // DEM
	std::string dem_path; // ز֮DEM
	std::string dem_r_path;// кӰ
	std::string dem_rc_path; // к 
	std::string sar_sim_wgs_path;
	std::string sar_sim_path;
	std::string in_sar_path;
	std::string sar_jpg_path;
	std::string sar_power_path;
	// ղƷ
	std::string out_dem_rc_path; // γкű任ļ

	std::string out_dem_slantRange_path; // бļ
	std::string out_plant_slantRange_path;// ƽбļ

	//// ASF  /////////////
	std::string out_lon_path;// 
	std::string out_lat_path;// γ
	std::string out_slantRange_path;// бļ

	/// ͬļ ///
	std::string out_localIncidenct_path;// ֵ
	std::string out_incidence_path; // ļ
	std::string out_ori_sim_tiff;// ӳļ'
	std::string out_sim_ori_tiff;
};

bool PtInRect(Point_3d pCur, Point_3d pLeftTop, Point_3d pRightTop, Point_3d pRightBelow, Point_3d pLeftBelow);